#include <qstring.h>
#include <stdio.h>
#include <math.h>

#include "xpath_value.h"

using namespace XPath;

QString s;

void print( int testno, const char *s )
{
    printf( "%d:\t\t%s\n", testno, s );
}

void print( int testno, const QString &s )
{
   print( testno, s.latin1() );
} 

int main( int /*argc*/, char **/*argv*/ )
{
    //
    // Test the Number type (tests 1000+)
    //
    print( 1000, "Number ======================" );

    Number anint( 12 );
    s = anint.toString().qstring();
    print( 1001, s );
    
    Number anint2( 12.0 );
    s = anint2.toString().qstring();
    print( 1002, s );
    
    Number adouble( 12.3 );
    s = adouble.toString().qstring();
    print( 1003, s );

    Number aposinf( 1.0/0.0 );
    s = aposinf.toString().qstring();
    print( 1004, s );

    Number aneginf( -1.0/0.0 );
    s = aneginf.toString().qstring();
    print( 1005, s );

    Number anan( acosh(0.5) );
    s = anan.toString().qstring();
    print( 1006, s );

    //
    // Test the Boolean type (tests 2000+)
    //
    print( 2000, "Boolean ======================" );

    Boolean afalse( false );
    s = afalse.toString().qstring();
    print( 2001, s );

    Boolean atrue( true );
    s = atrue.toString().qstring();
    print( 2002, s );

    //
    // Test the String type (tests 3000+)
    //
    print( 3000, "String ======================" );

    String astring( "the string" );
    s = astring.qstring();
    print( 3001, s );

    s = astring.toString().qstring();
    print( 3002, s );

    return 0;
}
