// program to test the new khtml implementation

#include <stdlib.h>
#include "kapplication.h"
// to be able to delete a static protected member pointer in kbrowser...
// just for memory debugging
#define protected public
#include "khtml_part.h"
#undef protected
#include <qcursor.h>
#include "dom/dom_string.h"
#include "dom/dom2_range.h"
#include "dom/html_document.h"
#include "dom/dom_exception.h"
#include <stdio.h>
#define protected public
#include "khtml_factory.h"
#undef protected
#include <qscrollview.h>
#include <kmainwindow.h>
#include <kcmdlineargs.h>

#include "xpath_session.h"
#include "xpath_value.h"
#include "test_xpath.h"

static KCmdLineOptions options[] = { { "+file", "url to open", 0 } , KCmdLineLastOption };

void Dummy::doit()
{
    fprintf( stderr, "========= About to do it =================\n" );
    DOM::Document d = m_part->document();
    XPath::Session xpath( d );
    xpath.select( DOM::DOMString("node") );
    fprintf( stderr, "================ Done it =================\n" );
}

int main(int argc, char *argv[])
{

    KCmdLineArgs::init(argc, argv, "testkhtml", "Testkhtml",
            "a basic web browser using the KHTML library", "1.0");
    KCmdLineArgs::addCmdLineOptions(options);

    KApplication a;
    KCmdLineArgs *args = KCmdLineArgs::parsedArgs( );
    if ( args->count() == 0 ) {
	KCmdLineArgs::usage();
	::exit( 1 );
    }

    KHTMLFactory *fac = new KHTMLFactory(true);

    KMainWindow *toplevel = new KMainWindow();
    KHTMLPart *doc = new KHTMLPart( toplevel, 0, toplevel, 0, KHTMLPart::BrowserViewGUI );

    Dummy *dummy = new Dummy( doc );
    QObject::connect( doc->browserExtension(), SIGNAL( openURLRequest( const KURL &, const KParts::URLArgs & ) ),
		      dummy, SLOT( slotOpenURL( const KURL&, const KParts::URLArgs & ) ) );

    QObject::connect( doc, SIGNAL(completed()), dummy, SLOT(doit()) );

    KParts::URLArgs ags(doc->browserExtension()->urlArgs());
    ags.serviceType = "text/xml";
    doc->browserExtension()->setURLArgs(ags);
    doc->openURL( args->url(0) );

    toplevel->setCentralWidget( doc->widget() );
    toplevel->resize( 800, 600);

    a.setTopWidget(doc->widget());
    QWidget::connect(doc, SIGNAL(setWindowCaption(const QString &)),
		     doc->widget()->topLevelWidget(), SLOT(setCaption(const QString &)));
    doc->widget()->show();
    toplevel->show();
    ((QScrollView *)doc->widget())->viewport()->show();


    int ret = a.exec();
    fac->deref();
    return ret;
}

