#include <qfile.h>
#include <qtextstream.h>

#include <kaboutdata.h>
#include <kapplication.h>
#include <kcmdlineargs.h>
#include <kdebug.h>
#include <klocale.h>

#include <khtml_part.h>
#include <khtmlview.h>
#include <kparts/browserextension.h>
#include <kparts/part.h>

#include "dom/dom_doc.h"
#include "dom/dom_element.h"
#include "dom/dom_string.h"

#include "query.h"
#include "value.h"
#include "xpath_node.h"
#include "value.h"

void interactive( KHTMLPart *html )
{
    DOM::Document doc = html->document();

    printf("Entering interactive mode.\n"
	   "Use debug() to print to the console. Press C-d or C-c to exit.\n\n");

    char buffer[1000];
    FILE *in = fdopen(0, "r");
    
    while (1) {
	printf("XPath> ");
	if (!fgets(buffer, 999, in))
	    break;
	QString query( buffer );
	query = query.stripWhiteSpace();

	XPath::Query xp;
	XPath::Value v = xp.select( query, doc.documentElement() );
	XPath::String s = v.toString();

	kdDebug() << "Value: " << v.qstring() << endl;
	kdDebug() << "String: " << s.qstring() << endl;
    }
}

void test_ast( KHTMLPart * )
{
    // XPathNode
    kdDebug() << "XPathNode" << endl;
    XPath::XPathNode n;
    kdDebug() << "\t" << n.qstring() << endl;

    //
    // Values
    //
    kdDebug() << endl << "Values" << endl;

    XPath::Value v;
    kdDebug() << "\t" << v.qstring() << endl;

    XPath::Exception vx;
    kdDebug() << "\t" << vx.qstring() << endl;

    XPath::NodeSet vns;
    kdDebug() << "\t" << vns.qstring() << endl;

    XPath::Boolean vb;
    kdDebug() << "\t" << vb.qstring() << endl;

    XPath::Number vnu;
    kdDebug() << "\t" << vnu.qstring() << endl;

    XPath::String vs;
    kdDebug() << "\t" << vs.qstring() << endl;
    vs = XPath::String( "testing a const char *" );
    kdDebug() << "\t" << vs.qstring() << endl;
    vs = XPath::String( QString("testing a QString") );
    kdDebug() << "\t" << vs.qstring() << endl;

    // Axes
    kdDebug() << endl << "Axes" << endl;
    XPath::Axis ax;
    for ( ushort i = 0 ; i < 16 ; i++ ) {
	ax = XPath::Axis( i );
	kdDebug() << "\t" << ax.qstring() << endl;
    }

    // BinaryOps
    kdDebug() << endl << "BinaryOps" << endl;
    XPath::BinaryOp bo;
    for ( ushort i = 0 ; i < 15 ; i++ ) {
	bo = XPath::BinaryOp( i );
	kdDebug() << "\t" << bo.qstring() << endl;
    }

    // Functions
    kdDebug() << endl << "Functions" << endl;
    XPath::FunctionCall f;
    for ( ushort i = 0 ; i < 30 ; i++ ) {
	f = XPath::FunctionCall( i );
	kdDebug() << "\t" << f.qstring() << endl;
    }
}
