//  -*- c++ -*-

/*
 *  This file is part of the KDE libraries
 *  Copyright (C) 2004 Richard Moore, rich@kde.org
 *  Copyright (C) 2004 Zack Rusin, zack@kde.org
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef XPATH_EXPRNODE_H
#define XPATH_EXPRNODE_H

#include <qvaluelist.h>

#include "xpath_value.h"

namespace XPath {

class Value;

class ExprNodeHelper
{
public:
    ExprNodeHelper();
    virtual ~ExprNodeHelper();

    virtual Value evaluate() const;
};

class ExprNode : public ExprNodeHelper
{
public:
    ExprNode();
    virtual ~ExprNode();

    int argCount() const { return args.count(); }

    String argString( uint idx ) const;
    Number argNumber( uint idx ) const;
    Boolean argBoolean( uint idx ) const;
private:
    QValueList<ExprNodeHelper> args;
};

} // namespace XPath

#endif // XPATH_EXPRNODE_H

// Local Variables:
// c-basic-offset: 4
// End:
