//  -*- c++ -*-

/*
 *  This file is part of the KDE libraries
 *  Copyright (C) 2004 Richard Moore, rich@kde.org
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef XPATH_FUNCTION_H
#define XPATH_FUNCTION_H

#include "xpath_exprnode.h"

namespace XPath {

/**
 * Represents a function call in an XPath expression AST.
 */
class FunctionCall : public ExprNode
{
public:
    enum FunctionCallId {
	FunctionBoolean, FunctionCeiling, FunctionConcat, FunctionContains,
	FunctionCount, FunctionFalse, FunctionFloor, FunctionId, FunctionLang,
	FunctionLast, FunctionLocalName, FunctionName, FunctionNamespaceURI,
	FunctionNormalizeSpace, FunctionNot, FunctionNumber, FunctionPosition,
	FunctionRound, FunctionStartsWith, FunctionString, FunctionStringLength,
	FunctionSubstring, FunctionSubstringAfter, FunctionSubstringBefore,
	FunctionSum, FunctionTranslate, FunctionTrue
    };

    FunctionCall( FunctionCallId func );
    ~FunctionCall();

    virtual Value evaluate() const;

private:
    FunctionCallId id;
};

} // namespace XPath

#endif // XPATH_FUNCTION_H

// Local Variables:
// c-basic-offset: 4
// End:
