//  -*- c++ -*-

/*
 *  This file is part of the KDE libraries
 *  Copyright (C) 2004 Richard Moore, rich@kde.org
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef XPATH_OPERATOR_H
#define XPATH_OPERATOR_H

#include <qvaluelist.h>

#include "xpath_value.h"

namespace XPath {

class Operator : public ExprNode
{
public:
    enum OperatorId {
	OperatorOr, OperatorAnd, OperatorEqual, OperatorNotEqual,
	OperatorLessThan, OperatorGreaterThan,
	OperatorLessThanEquals, OperatorGreaterThanEquals,
	OperatorUnaryMinus,
	OperatorDiv, OperatorMod,
	OperatorPlus, OperatorMinus, OperatorMultiply
    };

    Operator( OperatorId id );
    virtual ~Operator();

private:
    OperatorId id;
};

} // namespace XPath

#endif // XPATH_OPERATOR_H

// Local Variables:
// c-basic-offset: 4
// End:
