/*
 *  This file is part of the KDE libraries
 *  Copyright (C) 2004 Richard Moore, rich@kde.org
 *  Copyright (C) 2004 Zack Rusin, zack@kde.org
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <kdebug.h>

#include "dom/dom_doc.h"
#include "dom/dom_element.h"
#include "dom/dom2_traversal.h"

#include "xml/dom_docimpl.h"

#include "xpath_value.h"
#include "xpath_session.h"

namespace XPath {

Session::Session( const DOM::Document &document )
    : doc( static_cast<DOM::DocumentImpl *>(  document.handle() ) )
{
    if ( doc ) doc->ref();
}

Session::Session( const Session &other )
{
    doc = other.doc;
    if ( doc ) doc->ref();
}

Session& Session::operator=( const Session &other )
{
    if ( doc != other.doc ) {
        if ( doc ) doc->deref();
        doc = other.doc;
        if ( doc ) doc->ref();
    }
    return *this;
}

Session& Session::operator=( const DOM::Document &other )
{
    DOM::DocumentImpl *odoc = static_cast<DOM::DocumentImpl *>( other.handle() );
    if ( doc != odoc ) {
    if ( doc ) doc->deref();
	doc = odoc;
    if ( doc ) doc->ref();
    }
    return *this;
}

Session::~Session()
{
    if ( doc ) doc->deref();
}

Value Session::select( const DOM::DOMString &query )
{
    kdDebug() << "Select called" << endl;
/*
    DOM::TreeWalker walker = doc->createTreeWalker( doc->documentElement(),
                                                    DOM::NodeFilter::SHOW_ELEMENT,
                                                    DOM::NodeFilter(),
                                                    false );

    DOM::NodeList results;
    DOM::Node node = walker.nextNode();
    while ( !node.isNull() ) {
        kdDebug() << "Node: " << node.nodeName() << endl;

	if ( node.nodeName() == query ) {
	    kdDebug() << "Match: " << node.nodeName() << endl;
	}

	node = walker.nextNode();
    }
*/
}

} // namespace XPath

// Local Variables:
// c-basic-offset: 4
// End:
